%% Exercise Sheet 6 - 05.12.2013, Part II

% input:
% shift = 6;    (shift of the images)
% s = 0.1; (1b) convolve input-img with gaussian kernel with standard deviation s)
% g_patchRadius = 1;
% w,h = width / height of cropped-downsampled image
% W = (1 / scale) * w;    % width of upsampled image
% H = (1 / scale) * h;    % height of upsampled image
% n = W * H;

% output:
% M = A * B * S

function [M] = operators(shift, s, g_patchRadius, W, H, n)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Construct (Convolution/)Blurring Matrix B 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Gaussian Patch Dimensions
x_g = - g_patchRadius:1:g_patchRadius;
g_patchSize = (2 * g_patchRadius + 1)^2;


% Gaussian 1d Kernel
ker = exp(-(x_g.^2) / (2 * s^2));
ker = ker / sum(ker(:));
e_g = ones(n, 1);
E_g = [];
for i = 1:size(x_g, 2)
    E_g = [E_g, ker(i) * e_g];
end
N_x = -g_patchRadius:g_patchRadius; % = x_g

N_y = [];
for i = x_g 
    N_y = [N_y, i * W];    
end

B_x = spdiags(E_g, N_x, n, n);
B_y = spdiags(E_g, N_y, n, n);
B   = B_x * B_y;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Construct (warping/)shift matrix S 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
d = ones(W,1);
a = ones(n,1);
S = cell(1,shift);
for i = 1:shift
    m = spdiags(d, i, W, W);
    mm = speye(H, H);
    S{i} = kron(mm, m);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Build averaging matrix A 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% d = ones(W,1);  compare above
blockWeights = 0.25 * ones(2);
I = spdiags([d d d], [- W/2 0 W/2], W, W);
I_b = kron(I, blockWeights);
I_big = speye(n / (W * 2));     % n = W * H
A = kron(I_big, I_b);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate coefficient matrices 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
M = cell(1,shift);
for i = 1:shift
    M{i} = (A * B * S{i});
end


end

